Codeforces Round #367 (Div. 2) C. Hard problem(DP)

Hard problem

题目链接:

http://codeforces.com/contest/706/problem/C

Description

Vasiliy is fond of solving different tasks. Today he found one he wasn't able to solve himself, so he asks you to help.

Vasiliy is given n strings consisting of lowercase English letters. He wants them to be sorted in lexicographical order (as in the dictionary), but he is not allowed to swap any of them. The only operation he is allowed to do is to reverse any of them (first character becomes last, second becomes one before last and so on).

To reverse the i-th string Vasiliy has to spent ci units of energy. He is interested in the minimum amount of energy he has to spent in order to have strings sorted in lexicographical order.

String A is lexicographically smaller than string B if it is shorter than B (|A| < |B|) and is its prefix, or if none of them is a prefix of the other and at the first position where they differ character in A is smaller than the character in B.

For the purpose of this problem, two equal strings nearby do not break the condition of sequence being sorted lexicographically.

Input

The first line of the input contains a single integer n (2 ≤ n ≤ 100 000) — the number of strings.

The second line contains n integers ci (0 ≤ ci ≤ 109), the i-th of them is equal to the amount of energy Vasiliy has to spent in order to reverse the i-th string.

Then follow n lines, each containing a string consisting of lowercase English letters. The total length of these strings doesn't exceed 100 000.

Output

If it is impossible to reverse some of the strings such that they will be located in lexicographical order, print  - 1. Otherwise, print the minimum total amount of energy Vasiliy has to spent.

Examples


input
2
1 2
ba
ac
output
1
input
3
1 3 1
aa
ba
ac
output
1
input
2
5 5
bbb
aaa
output
-1
input
2
3 3
aaa
aa
output
-1

Source


Codeforces Round #367 (Div. 2)


题意:


给出若干个字符串,反转一个字符串有对应的花费.
求最小花费使得字符串按字典升序.


题解:


因为每个字符串要么反转要么不翻转. 所以直接用dp来做:
dp[i][0]:第i个字符串不反转且使得前i个串升序的最小代价.
dp[i][1]:第i个字符串反转且使得前i个串升序的最小代价.
这里先预处理出每个串的反转,每次要先比较能否保持升序再作更新.


代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <vector>
#include <list>
#define LL long long
#define eps 1e-8
#define maxn 101000
#define mod 100000007
#define inf 0x3f3f3f3f3f3f3f3f
#define mid(a,b) ((a+b)>>1)
#define IN freopen("in.txt","r",stdin);
using namespace std;

int n;
string str[maxn];
string rev[maxn];
LL cost[maxn];
LL dp[maxn][2];

int main(int argc, char const *argv[])
{
    //IN;

    while(scanf("%d", &n) != EOF)
    {
        for(int i=1; i<=n; i++) {
            cin >> cost[i];
        }
        for(int i=1; i<=n; i++) {
            cin >> str[i];
            rev[i] = str[i];
            reverse(rev[i].begin(), rev[i].end());
        }

        dp[1][0] = 0;
        dp[1][1] = cost[1];
        for(int i=2; i<=n; i++) {
            dp[i][0] = dp[i][1] = inf;
            if(str[i] >= str[i-1]) {
                dp[i][0] = min(dp[i][0], dp[i-1][0]);
            }
            if(str[i] >= rev[i-1]) {
                dp[i][0] = min(dp[i][0], dp[i-1][1]);
            }

            if(rev[i] >= str[i-1]) {
                dp[i][1] = min(dp[i][1], dp[i-1][0]+cost[i]);
            }
            if(rev[i] >= rev[i-1]) {
                dp[i][1] = min(dp[i][1], dp[i-1][1]+cost[i]);
            }
        }

        if(dp[n][0] == inf && dp[n][1] == inf) printf("-1\n");
        else printf("%I64d\n", min(dp[n][0],dp[n][1]));
    }

    return 0;
}

转载于:https://www.cnblogs.com/Sunshine-tcf/p/5793582.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值